///###////////////////////////////////////////////////////////////////////////
//
// Burton Computer Corporation
// http://www.burton-computer.com
// http://www.cooldevtools.com
// $Id$
//
// Copyright (C) 2000 Burton Computer Corporation
// ALL RIGHTS RESERVED
//
// This program is open source software; you can redistribute it
// and/or modify it under the terms of the Q Public License (QPL)
// version 1.0. Use of this software in whole or in part, including
// linking it (modified or unmodified) into other programs is
// subject to the terms of the QPL.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// Q Public License for more details.
//
// You should have received a copy of the Q Public License
// along with this program; see the file LICENSE.txt.  If not, visit
// the Burton Computer Corporation or CoolDevTools web site
// QPL pages at:
//
//    http://www.burton-computer.com/qpl.html
//    http://www.cooldevtools.com/qpl.html
//

package org.cooldevtools.apps.clnews.configure;

import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import org.cooldevtools.awt.*;

public class DetailButtonPanel
extends JPanel
{
   public DetailButtonPanel()
   {
      initDisplay();
   }

   private void initDisplay()
   {
      m_deleteButton = new JButton("Delete");
      m_applyButton  = new JButton("Apply");
      m_revertButton = new JButton("Revert");

      setLayout(new EqualSizeLayout(5));
      add(m_deleteButton);
      add(new Gap());
      add(m_applyButton);
      add(m_revertButton);

      setEmpty(true);
   }

   public void setEmpty(boolean value)
   {
      m_isEmpty = value;
      m_deleteButton.setEnabled(m_canDelete && !value);
      m_applyButton.setEnabled(false);
      m_revertButton.setEnabled(false);
   }

   public boolean isEmpty()
   {
      return m_isEmpty;
   }

   public void setDirty(boolean value)
   {
      if (value) {
         m_deleteButton.setEnabled(m_canDelete);
         m_applyButton.setEnabled(true);
         m_revertButton.setEnabled(true);
      } else {
         m_deleteButton.setEnabled(m_canDelete);
         m_applyButton.setEnabled(false);
         m_revertButton.setEnabled(false);
      }
   }

   public void setCanDelete(boolean value)
   {
      m_canDelete = value;
   }

   public boolean isDirty()
   {
      return m_applyButton.isEnabled();
   }

   public void addDeleteListener(ActionListener al)
   {
      m_deleteButton.addActionListener(al);
   }

   public void addApplyListener(ActionListener al)
   {
      m_applyButton.addActionListener(al);
   }

   public void addRevertListener(ActionListener al)
   {
      m_revertButton.addActionListener(al);
   }

   public static void main(String[] args)
   {
      JFrame f = new JFrame();
      JPanel dbp = new DetailButtonPanel();
      dbp.setBorder(new EmptyBorder(5, 5, 5, 5));
      f.getContentPane().add(dbp);
      f.pack();
      f.show();
   }

   private JButton m_deleteButton;
   private JButton m_applyButton;
   private JButton m_revertButton;
   private boolean m_canDelete;
   private boolean m_isEmpty;
}

