///###////////////////////////////////////////////////////////////////////////
//
// Burton Computer Corporation
// http://www.burton-computer.com
// http://www.cooldevtools.com
// $Id$
//
// Copyright (C) 2000 Burton Computer Corporation
// ALL RIGHTS RESERVED
//
// This program is open source software; you can redistribute it
// and/or modify it under the terms of the Q Public License (QPL)
// version 1.0. Use of this software in whole or in part, including
// linking it (modified or unmodified) into other programs is
// subject to the terms of the QPL.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// Q Public License for more details.
//
// You should have received a copy of the Q Public License
// along with this program; see the file LICENSE.txt.  If not, visit
// the Burton Computer Corporation or CoolDevTools web site
// QPL pages at:
//
//    http://www.burton-computer.com/qpl.html
//    http://www.cooldevtools.com/qpl.html
//

package org.cooldevtools.apps.clnews.configure;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import javax.swing.text.*;
import org.cooldevtools.utility.*;
import org.cooldevtools.awt.*;

public class NewsGroupDetailPanel
extends JPanel
{
   public NewsGroupDetailPanel()
   {
      initDisplay(new ModifiedEventHelper());
   }

   public NewsGroupDetailPanel(ModifiedEventHelper modified)
   {
      initDisplay(modified);
   }

   private void initDisplay(ModifiedEventHelper modified)
   {
      setLayout(new GapFlowLayout(5, true));
      setBorder(Constants.PANEL_BORDER);

      m_fields = new BasicFieldPanel();
      m_fields.addField(GROUP_NAME, "Name: ", "", 20);
      m_fields.addField(OWNER_EMAIL, "Email: ", "", 20);
      m_fields.addField(DESCRIPTION, "Description: ", "", 20);
      m_fields.getField(GROUP_NAME).setDocument(new RejectChars(RejectChars.GROUP_CHARS));
      m_fields.addDocumentListener(modified);

      m_fields.setMnemonic(GROUP_NAME,  'N');
      m_fields.setMnemonic(OWNER_EMAIL, 'E');
      m_fields.setMnemonic(DESCRIPTION, 'D');

      add(m_fields);
   }

   public static void main(String[] args)
   {
      JFrame f = new JFrame();
      NewsGroupDetailPanel r = new NewsGroupDetailPanel();

      r.setNewsGroupName("alt.coffee_server.discuss");
      r.setOwnerEmail("admin@nowhere.com");
      r.setDescription("This is a very important group.\n\nWe talk about things here...\n");
      f.getContentPane().add(r);
      f.pack();
      f.show();
   }

   public void setNewsGroupNameEditable(boolean value)
   {
      m_fields.getField(GROUP_NAME).setEditable(value);
   }

   public String getNewsGroupName()
   {
      return m_fields.getField(GROUP_NAME).getText();
   }

   public void setNewsGroupName(String value)
   {
      m_fields.getField(GROUP_NAME).setText(value);
   }

   public String getOwnerEmail()
   {
      return m_fields.getField(OWNER_EMAIL).getText();
   }

   public void setOwnerEmail(String value)
   {
      m_fields.getField(OWNER_EMAIL).setText(value);
   }

   public String getDescription()
   {
      return m_fields.getField(DESCRIPTION).getText();
   }

   public void setDescription(String value)
   {
      m_fields.getField(DESCRIPTION).setText(value);
   }

   private BasicFieldPanel m_fields;

   private static final int GROUP_NAME  = 0;
   private static final int OWNER_EMAIL = 1;
   private static final int DESCRIPTION = 2;
}

