///###////////////////////////////////////////////////////////////////////////
//
// Burton Computer Corporation
// http://www.burton-computer.com
// http://www.cooldevtools.com
// $Id$
//
// Copyright (C) 2000 Burton Computer Corporation
// ALL RIGHTS RESERVED
//
// This program is open source software; you can redistribute it
// and/or modify it under the terms of the Q Public License (QPL)
// version 1.0. Use of this software in whole or in part, including
// linking it (modified or unmodified) into other programs is
// subject to the terms of the QPL.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// Q Public License for more details.
//
// You should have received a copy of the Q Public License
// along with this program; see the file LICENSE.txt.  If not, visit
// the Burton Computer Corporation or CoolDevTools web site
// QPL pages at:
//
//    http://www.burton-computer.com/qpl.html
//    http://www.cooldevtools.com/qpl.html
//

package org.cooldevtools.apps.clnews.configure;

import javax.swing.text.*;
import org.cooldevtools.utility.Assert;

class RejectChars
extends DefaultStyledDocument
{
   public RejectChars(char[] chars)
   {
      m_chars = chars;
   }

   public void setAllowedChars(char[] chars)
   {
      m_chars = chars;
   }

   private boolean isAllowed(char ch)
   {
      for (int i = 0; i < m_chars.length; i++) {
         if (m_chars[i] == ch) {
            return true;
         }
      }
      if (Assert.DEBUG) {
         System.out.println("Rejected character '" + ch + "' (" + (int)ch + ")");
      }
      return false;
   }

   public void insertString(int offset,
                            String str,
                            AttributeSet attributes)
   throws BadLocationException
   {
      char[] ch = str.toCharArray();
      for (int i = 0; i < ch.length; i++) {
         if ((!Character.isLetterOrDigit(ch[i])) && !isAllowed(ch[i])) {
            return;
         }
      }
      super.insertString(offset, str, attributes);
   }

   private char[] m_chars;

   public static char[] GROUP_CHARS = {
      '.', '-'
   };
   public static char[] NAME_CHARS = {
      '_', '-'
   };
   public static char[] HOST_CHARS = {
      '.', '-'
   };
}

