///###////////////////////////////////////////////////////////////////////////
//
// Burton Computer Corporation
// http://www.burton-computer.com
// http://www.cooldevtools.com
// $Id$
//
// Copyright (C) 2000 Burton Computer Corporation
// ALL RIGHTS RESERVED
//
// This program is open source software; you can redistribute it
// and/or modify it under the terms of the Q Public License (QPL)
// version 1.0. Use of this software in whole or in part, including
// linking it (modified or unmodified) into other programs is
// subject to the terms of the QPL.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// Q Public License for more details.
//
// You should have received a copy of the Q Public License
// along with this program; see the file LICENSE.txt.  If not, visit
// the Burton Computer Corporation or CoolDevTools web site
// QPL pages at:
//
//    http://www.burton-computer.com/qpl.html
//    http://www.cooldevtools.com/qpl.html
//


package org.cooldevtools.awt;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class BasicContainerPanel
  extends JPanel
  implements ActionListener
{
  public BasicContainerPanel()
    {
      m_helper = new ActionEventHelper();
      m_changed = false;
    }

  public void addActionListener(ActionListener listener)
    {
      m_helper.addActionListener(listener);
    }

  public void removeActionListener(ActionListener listener)
    {
      m_helper.removeActionListener(listener);
    }

  public void actionPerformed(ActionEvent e)
    {
      fireActionEvent(e);
      m_changed = true;
    }

  public boolean getChanged()
    {
      return m_changed;
    }

  public void setChanged(boolean value)
    {
      m_changed = value;
    }

  protected void fireActionEvent(ActionEvent e)
    {
      m_helper.fireActionEvent(e);
    }

  private boolean m_changed;
  private ActionEventHelper m_helper;
}
