///###////////////////////////////////////////////////////////////////////////
//
// Burton Computer Corporation
// http://www.burton-computer.com
// http://www.cooldevtools.com
// $Id$
//
// Copyright (C) 2000 Burton Computer Corporation
// ALL RIGHTS RESERVED
//
// This program is open source software; you can redistribute it
// and/or modify it under the terms of the Q Public License (QPL)
// version 1.0. Use of this software in whole or in part, including
// linking it (modified or unmodified) into other programs is
// subject to the terms of the QPL.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// Q Public License for more details.
//
// You should have received a copy of the Q Public License
// along with this program; see the file LICENSE.txt.  If not, visit
// the Burton Computer Corporation or CoolDevTools web site
// QPL pages at:
//
//    http://www.burton-computer.com/qpl.html
//    http://www.cooldevtools.com/qpl.html
//

package org.cooldevtools.awt;

import javax.swing.text.*;

public class BasicIntegerDocument
extends DefaultStyledDocument
{
   public BasicIntegerDocument(boolean allow_sign)
   {
      m_allowSign = allow_sign;
   }

   private boolean isAllowed(int offset,
                             char[] ch)
   {
      if (Character.isDigit(ch[offset])) {
         return true;
      }
      if (!m_allowSign || (offset != 0)) {
         return false;
      }
      if ((ch[0] != '+') && (ch[0] != '-')) {
         return false;
      }
      if (ch.length == 0) {
         return false;
      }
      return Character.isDigit(ch[1]);
   }

   public void insertString(int offset,
                            String str,
                            AttributeSet attributes)
   throws BadLocationException
   {
      char[] ch = str.toCharArray();
      for (int i = 0; i < ch.length; i++) {
         if (!isAllowed(i, ch)) {
            return;
         }
      }
      super.insertString(offset, str, attributes);
   }

   private boolean m_allowSign;
}

