///###////////////////////////////////////////////////////////////////////////
//
// Burton Computer Corporation
// http://www.burton-computer.com
// http://www.cooldevtools.com
// $Id$
//
// Copyright (C) 2000 Burton Computer Corporation
// ALL RIGHTS RESERVED
//
// This program is open source software; you can redistribute it
// and/or modify it under the terms of the Q Public License (QPL)
// version 1.0. Use of this software in whole or in part, including
// linking it (modified or unmodified) into other programs is
// subject to the terms of the QPL.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// Q Public License for more details.
//
// You should have received a copy of the Q Public License
// along with this program; see the file LICENSE.txt.  If not, visit
// the Burton Computer Corporation or CoolDevTools web site
// QPL pages at:
//
//    http://www.burton-computer.com/qpl.html
//    http://www.cooldevtools.com/qpl.html
//


package org.cooldevtools.awt;

import java.awt.*;
import javax.swing.*;

public class BasicRadioPanel
  extends BasicContainerPanel
{
  public BasicRadioPanel(int rows,
			 int columns)
    {
      setLayout(new GridLayout(rows, columns));
      m_group = new ButtonGroup();
      m_numButtons = 0;
      m_buttons = new JRadioButton[rows * columns];
    }

  public void setEnabled(boolean value)
    {
      super.setEnabled(value);
      for (int i = 0; i < m_numButtons; i++)
	{
	  m_buttons[i].setEnabled(value);
	}
    }

  public void addButton(String label,
			boolean selected)
    {
      JRadioButton button = new JRadioButton(label);

      m_buttons[m_numButtons++] = button;
      m_group.add(button);
      add(button);

      button.addActionListener(this);
      button.setSelected(selected);
    }

  public int getSelectedIndex()
    {
      for (int i = 0; i < m_numButtons; i++)
	{
	  if (m_buttons[i].isSelected())
	    {
	      return i;
	    }
	}

      return -1;
    }

  public void setSelectedIndex(int index)
    {
      m_buttons[index].setSelected(true);
    }

  private ButtonGroup m_group;
  private JRadioButton[] m_buttons;
  private int m_numButtons;
}
