///###////////////////////////////////////////////////////////////////////////
//
// Burton Computer Corporation
// http://www.burton-computer.com
// http://www.cooldevtools.com
// $Id$
//
// Copyright (C) 2000 Burton Computer Corporation
// ALL RIGHTS RESERVED
//
// This program is open source software; you can redistribute it
// and/or modify it under the terms of the Q Public License (QPL)
// version 1.0. Use of this software in whole or in part, including
// linking it (modified or unmodified) into other programs is
// subject to the terms of the QPL.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// Q Public License for more details.
//
// You should have received a copy of the Q Public License
// along with this program; see the file LICENSE.txt.  If not, visit
// the Burton Computer Corporation or CoolDevTools web site
// QPL pages at:
//
//    http://www.burton-computer.com/qpl.html
//    http://www.cooldevtools.com/qpl.html
//

package org.cooldevtools.awt;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class DialogUtil extends JDialog
{
   public static class EscapeActionListener implements ActionListener {
      EscapeActionListener(JDialog dialog)
      {
	 m_dialog = dialog;
      }

      public void actionPerformed(ActionEvent ev)
      {
	 m_dialog.setVisible(false);
      }

      private JDialog m_dialog;
   }

   public static void setToExitOnEscape(JDialog dialog)
   {
      setKeyStrokeListener(dialog, KeyEvent.VK_ESCAPE, new EscapeActionListener(dialog));
   }

   public static void setEscapeListener(JDialog dialog,
					ActionListener listener)
   {
      setKeyStrokeListener(dialog, KeyEvent.VK_ESCAPE, listener);
   }

   public static void setKeyStrokeListener(JDialog dialog,
					   int key,
					   ActionListener listener)
   {
      JRootPane root_pane = dialog.getRootPane();
      KeyStroke stroke = KeyStroke.getKeyStroke(key, 0);
      root_pane.registerKeyboardAction(listener, stroke, JComponent.WHEN_IN_FOCUSED_WINDOW);
   }
}
