///###////////////////////////////////////////////////////////////////////////
//
// Burton Computer Corporation
// http://www.burton-computer.com
// http://www.cooldevtools.com
// $Id$
//
// Copyright (C) 2000 Burton Computer Corporation
// ALL RIGHTS RESERVED
//
// This program is open source software; you can redistribute it
// and/or modify it under the terms of the Q Public License (QPL)
// version 1.0. Use of this software in whole or in part, including
// linking it (modified or unmodified) into other programs is
// subject to the terms of the QPL.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// Q Public License for more details.
//
// You should have received a copy of the Q Public License
// along with this program; see the file LICENSE.txt.  If not, visit
// the Burton Computer Corporation or CoolDevTools web site
// QPL pages at:
//
//    http://www.burton-computer.com/qpl.html
//    http://www.cooldevtools.com/qpl.html
//


package org.cooldevtools.coffee_server;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import org.cooldevtools.awt.*;
import org.cooldevtools.coffee_server.config.*;

public class Configure
{
  public static final void main(String[] args)
    {
      try
	{
	  String filename = null;
	  switch (args.length)
	    {
	    case 0:
	      break;

	    case 1:
	      filename = args[0];
	      break;

	    default:
	      System.err.println("usage: Configure [filename]");
	      System.exit(1);
	    }

	  try
	    {
	      // try to set a more attractive look and feel than the default
	      UIManager.setLookAndFeel(LOOK_AND_FEEL);
	    }
	  catch (Exception ex)
	    {
	    }

	  ConfigFrame f = new ConfigFrame("CoffeeServer Configuration Tool");
	  ConfigFrameDriver driver = new ConfigFrameDriver(f, filename);
	  f.show();
	}
      catch (Exception ex)
	{
	  ex.printStackTrace();
	}
    }

  private static final String LOOK_AND_FEEL = 
    "javax.swing.plaf.motif.MotifLookAndFeel___";
}
