///###////////////////////////////////////////////////////////////////////////
//
// Burton Computer Corporation
// http://www.burton-computer.com
// http://www.cooldevtools.com
// $Id$
//
// Copyright (C) 2000 Burton Computer Corporation
// ALL RIGHTS RESERVED
//
// This program is open source software; you can redistribute it
// and/or modify it under the terms of the Q Public License (QPL)
// version 1.0. Use of this software in whole or in part, including
// linking it (modified or unmodified) into other programs is
// subject to the terms of the QPL.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// Q Public License for more details.
//
// You should have received a copy of the Q Public License
// along with this program; see the file LICENSE.txt.  If not, visit
// the Burton Computer Corporation or CoolDevTools web site
// QPL pages at:
//
//    http://www.burton-computer.com/qpl.html
//    http://www.cooldevtools.com/qpl.html
//


package org.cooldevtools.coffee_server.config;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import org.cooldevtools.coffee_server.framework.*;

public class BeanPageDriver
{
  public BeanPageDriver(ConfigFrame frame)
    {
      m_frame = frame;
      init();
    }

  private void init()
    {
      m_frame.getBeanOK().addActionListener(new OKListener());
      m_frame.getBeanCancel().addActionListener(new CancelListener());
    }

  private void reset()
    {
      m_info = null;
      m_bean = null;
      m_frame.showMainPage();
    }

  public class OKListener
    implements ActionListener
  {
    public void actionPerformed(ActionEvent e)
      {
	StringBuffer message = new StringBuffer();
	if (m_bean.isValidConfiguration(message))
	  {
	    m_info.setConfiguration(m_bean.getConfiguration());
	    reset();
	  }
	else
	  {
	    JOptionPane.showMessageDialog(null,
					  message.toString(),
					  "Error",
					  JOptionPane.ERROR_MESSAGE);
	  }
      }
  }

  public class CancelListener
    implements ActionListener
  {
    public void actionPerformed(ActionEvent e)
      {
	reset();
      }
  }

  public void execute(ServiceConfigInfo service)
    {
      try
	{
	  m_info = service;
	  m_bean = m_info.getBean();
	  m_bean.setConfiguration(m_info.getConfiguration());
	  m_frame.showBeanPage(m_bean.getComponent());
	}
      catch (CoffeeServiceException ex)
	{
	  ex.printStackTrace();
	}
    }

  public static final void main(String[] args)
    {
      try
	{
	  ConfigFrame f = new ConfigFrame("Testing");

	  ServiceConfigInfo info = new ServiceConfigInfo();
	  info.setName("Hello");
	  info.setPort(10);
	  info.setClassName("org.cooldevtools.coffee_server.services.test.Hello");
     //BTB     info.setConfiguration("Initial message.".getBytes());
	  new BeanPageDriver(f).execute(info);
	  f.show();
	}
      catch (Exception ex)
	{
	  ex.printStackTrace();
	}
    }

  private ServiceConfigInfo m_info;
  private CoffeeServiceConfigBean m_bean;
  private ConfigFrame m_frame;
}
