///###////////////////////////////////////////////////////////////////////////
//
// Burton Computer Corporation
// http://www.burton-computer.com
// http://www.cooldevtools.com
// $Id$
//
// Copyright (C) 2000 Burton Computer Corporation
// ALL RIGHTS RESERVED
//
// This program is open source software; you can redistribute it
// and/or modify it under the terms of the Q Public License (QPL)
// version 1.0. Use of this software in whole or in part, including
// linking it (modified or unmodified) into other programs is
// subject to the terms of the QPL.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// Q Public License for more details.
//
// You should have received a copy of the Q Public License
// along with this program; see the file LICENSE.txt.  If not, visit
// the Burton Computer Corporation or CoolDevTools web site
// QPL pages at:
//
//    http://www.burton-computer.com/qpl.html
//    http://www.cooldevtools.com/qpl.html
//


package org.cooldevtools.coffee_server.config;

import javax.swing.*;
import org.cooldevtools.awt.*;

public class FrameworkConfigPanel
  extends JPanel
{
  public FrameworkConfigPanel()
    {
      initDisplay();
    }

  public void setNumThreads(int value)
    {
      m_threads.setText(String.valueOf(value));
    }

  public int getNumThreads()
    {
      try
	{
	  return Integer.parseInt(m_threads.getText());
	}
      catch (NumberFormatException ex)
	{
	  return 0;
	}
    }

  private void initDisplay()
    {
      GridBagHelper gb = new GridBagHelper(this);

      gb.setBounds(0, 0, 1, 1);
      gb.addComponent(new JLabel("Threads:", SwingConstants.RIGHT));

      gb.setBounds(1, 0, 2, 1);
      m_threads = new JTextField(NUM_THREADS_WIDTH);
      gb.addComponent(m_threads);
    }

  public static final void main(String[] args)
    {
      JFrame f = new JFrame("Testing");
      f.getContentPane().add(new FrameworkConfigPanel());
      f.pack();
      f.show();
    }

  public JTextField getThreads()
    {
      return m_threads;
    }

  private JTextField m_threads;

  private static final int NUM_THREADS_WIDTH = 10;
}
