///###////////////////////////////////////////////////////////////////////////
//
// Burton Computer Corporation
// http://www.burton-computer.com
// http://www.cooldevtools.com
// $Id$
//
// Copyright (C) 2000 Burton Computer Corporation
// ALL RIGHTS RESERVED
//
// This program is open source software; you can redistribute it
// and/or modify it under the terms of the Q Public License (QPL)
// version 1.0. Use of this software in whole or in part, including
// linking it (modified or unmodified) into other programs is
// subject to the terms of the QPL.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// Q Public License for more details.
//
// You should have received a copy of the Q Public License
// along with this program; see the file LICENSE.txt.  If not, visit
// the Burton Computer Corporation or CoolDevTools web site
// QPL pages at:
//
//    http://www.burton-computer.com/qpl.html
//    http://www.cooldevtools.com/qpl.html
//


package org.cooldevtools.coffee_server.framework;

import java.io.*;
import java.net.*;

/**
   Interface for client request implementations.
   For now just a Socket wrapper.
 */
public interface ClientRequest
{
   public CoffeeServiceManager getServiceManager();
   public CoffeeServer getServer();

   public InetAddress getInetAddress();

   public InetAddress getLocalAddress();

   public int getPort();

   public int getLocalPort();

   public InputStream getInputStream()
   throws IOException;

   public OutputStream getOutputStream()
   throws IOException;

   public void setTcpNoDelay(boolean on)
   throws SocketException;

   public boolean getTcpNoDelay()
   throws SocketException;

   public void setSoLinger(boolean on,
                           int val)
   throws SocketException;

   public int getSoLinger()
   throws SocketException;

   public void setSoTimeout(int timeout)
   throws SocketException;

   public int getSoTimeout()
   throws SocketException;

   public void close()
   throws IOException;
}
