///###////////////////////////////////////////////////////////////////////////
//
// Burton Computer Corporation
// http://www.burton-computer.com
// http://www.cooldevtools.com
// $Id$
//
// Copyright (C) 2000 Burton Computer Corporation
// ALL RIGHTS RESERVED
//
// This program is open source software; you can redistribute it
// and/or modify it under the terms of the Q Public License (QPL)
// version 1.0. Use of this software in whole or in part, including
// linking it (modified or unmodified) into other programs is
// subject to the terms of the QPL.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// Q Public License for more details.
//
// You should have received a copy of the Q Public License
// along with this program; see the file LICENSE.txt.  If not, visit
// the Burton Computer Corporation or CoolDevTools web site
// QPL pages at:
//
//    http://www.burton-computer.com/qpl.html
//    http://www.cooldevtools.com/qpl.html
//


package org.cooldevtools.coffee_server.framework;

import java.io.*;
import java.net.*;

/**
   Class which holds complete requests in the thread pool.
 */
public class PendingRequest
{
   PendingRequest(ExceptionHandler handler,
                  ClientRequest request,
                  CoffeeService service)
   {
      m_handler = handler;
      m_request = request;
      m_service = service;
   }

   public void execute()
   {
      try {
         m_service.serviceRequest(m_request);
      } catch (Exception ex) {
         m_handler.serviceFailure(m_request, m_service, ex);
      }
   }

   private ClientRequest m_request;
   private CoffeeService m_service;
   private ExceptionHandler m_handler;
}
