///###////////////////////////////////////////////////////////////////////////
//
// Burton Computer Corporation
// http://www.burton-computer.com
// http://www.cooldevtools.com
// $Id$
//
// Copyright (C) 2000 Burton Computer Corporation
// ALL RIGHTS RESERVED
//
// This program is open source software; you can redistribute it
// and/or modify it under the terms of the Q Public License (QPL)
// version 1.0. Use of this software in whole or in part, including
// linking it (modified or unmodified) into other programs is
// subject to the terms of the QPL.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// Q Public License for more details.
//
// You should have received a copy of the Q Public License
// along with this program; see the file LICENSE.txt.  If not, visit
// the Burton Computer Corporation or CoolDevTools web site
// QPL pages at:
//
//    http://www.burton-computer.com/qpl.html
//    http://www.cooldevtools.com/qpl.html
//


package org.cooldevtools.coffee_server.framework;

import java.io.*;
import java.net.*;
import org.cooldevtools.coffee_server.util.*;

/**
   Thread attached to thread pool to handle requests.
 */
public class ThreadPoolWorker
  extends Thread
{
  public ThreadPoolWorker(ThreadPool pool,
			  ExceptionHandler handler)
    {
      m_pool = pool;
      m_handler = handler;
    }

  public void run()
    {
      try
	{
	  while (true)
	    {
	      PendingRequest request = (PendingRequest)m_pool.get();
	      request.execute();
	    }
	}
      catch (ThreadPoolClosedException ex)
	{
	}
      catch (InterruptedException ex2)
	{
	}
    }

  private ThreadPool m_pool;
  private ExceptionHandler m_handler;
}
