///###////////////////////////////////////////////////////////////////////////
//
// Burton Computer Corporation
// http://www.burton-computer.com
// http://www.cooldevtools.com
// $Id$
//
// Copyright (C) 2000 Burton Computer Corporation
// ALL RIGHTS RESERVED
//
// This program is open source software; you can redistribute it
// and/or modify it under the terms of the Q Public License (QPL)
// version 1.0. Use of this software in whole or in part, including
// linking it (modified or unmodified) into other programs is
// subject to the terms of the QPL.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// Q Public License for more details.
//
// You should have received a copy of the Q Public License
// along with this program; see the file LICENSE.txt.  If not, visit
// the Burton Computer Corporation or CoolDevTools web site
// QPL pages at:
//
//    http://www.burton-computer.com/qpl.html
//    http://www.cooldevtools.com/qpl.html
//

package org.cooldevtools.coffee_server.services.nntp.protocol;

import java.io.*;
import java.util.*;
import org.cooldevtools.coffee_server.framework.*;
import org.cooldevtools.coffee_server.services.nntp.pub.*;

public class NntpService_MODE_READER extends NntpCommand
{
   public NntpService_MODE_READER()
   {
      super(false);
   }

   public static void greetReader(NntpSession session,
                                  NntpWriter out)
   throws IOException, CoffeeServiceException
   {
      User user = session.getUser();
      if (CONFORM) {
	 // what we have to do to work with idiot news readers...
	 out.writeResponse(ServerConnection.CODE_AUTH_CAN_POST, "Welcome to CoffeeLink News Server http://www.burton-computer.com");
      } else {
	 /* This is what SHOULD be here but Netscape disables the NewMsg button unless
	    we answer with a 200! And OutlookExpress just gives up if it doesn't see
	    200 when it connects!
	 */
	 if (!session.isAuthenticated()) {
	    out.writeResponse(ServerConnection.CODE_AUTH_REQUIRED, "Authentication required");
	 } else if (user.canPost()) {
	    out.writeResponse(ServerConnection.CODE_AUTH_CAN_POST, "Hello, you can post");
	 } else if (user.canRead()) {
	    out.writeResponse(ServerConnection.CODE_AUTH_CAN_READ, "Hello, you can't post");
	 } else {
	    out.writeResponse(ServerConnection.CODE_AUTH_CAN_READ, "Hello, you can't post");
	 }
      }
   }

   public boolean executeCommand(NntpSession session,
                                 NntpReader in,
                                 NntpWriter out)
   throws IOException, CoffeeServiceException
   {
      String arg = in.getNextCommand();
      if (arg.equals(READER)) {
	 greetReader(session, out);
	 return true;
      }

      return false;
   }

   private static final String READER = "reader";
   private static final boolean CONFORM = true;
}
