///###////////////////////////////////////////////////////////////////////////
//
// Burton Computer Corporation
// http://www.burton-computer.com
// http://www.cooldevtools.com
// $Id$
//
// Copyright (C) 2000 Burton Computer Corporation
// ALL RIGHTS RESERVED
//
// This program is open source software; you can redistribute it
// and/or modify it under the terms of the Q Public License (QPL)
// version 1.0. Use of this software in whole or in part, including
// linking it (modified or unmodified) into other programs is
// subject to the terms of the QPL.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// Q Public License for more details.
//
// You should have received a copy of the Q Public License
// along with this program; see the file LICENSE.txt.  If not, visit
// the Burton Computer Corporation or CoolDevTools web site
// QPL pages at:
//
//    http://www.burton-computer.com/qpl.html
//    http://www.cooldevtools.com/qpl.html
//


package org.cooldevtools.coffee_server.services.nntp.protocol;

import java.io.*;
import java.util.*;
import java.text.*;
import org.cooldevtools.coffee_server.framework.*;
import org.cooldevtools.coffee_server.services.nntp.pub.*;

public class NntpService_NEWGROUPS extends NntpCommand
{
   public NntpService_NEWGROUPS()
   {
   }

   public static void main(String[] args)
   {
      try {
         for (int i = 0; i < args.length; i++) {
            System.out.print(args[i]);
            System.out.print(": ");
            System.out.println(NntpDate.parseDate(args[i]).toString());
         }
      } catch (Exception ex) {
         ex.printStackTrace();
      }
   }

   public boolean list(NntpSession session,
                       NntpReader in,
                       NntpWriter out,
                       Date when)
   throws IOException, CoffeeServiceException
   {
      User user = session.getUser();
      NewsGroup[] groups = session.getNewsGroups().getNewsGroupsNewerThan(when);

      out.writeResponse(231, "list of newsgroups follows");

      for (int i = 0; i < groups.length; i++) {
         NewsGroup group = groups[i];
         if (user.canReadNewsGroup(group)) {
            StringBuffer buffer = new StringBuffer();
            buffer.append(group.getName());
            buffer.append(" ");
            buffer.append(group.getHighMessageIndex());
            buffer.append(" ");
            buffer.append(group.getLowMessageIndex());
            buffer.append(user.canPostToNewsGroup(group) ? " y" : " n");
            out.writeEscapedText(buffer.toString());
         }
      }

      out.writeEndOfText();

      return true;
   }


   public boolean executeCommand(NntpSession session,
                                 NntpReader in,
                                 NntpWriter out)
   throws IOException, CoffeeServiceException
   {
      String arg = in.getRemainderOfLine();

      if (arg.length() == 0) {
         return false;
      }

      Date when = NntpDate.parseDate(arg);
      return list(session, in, out, when);
   }
}
