///###////////////////////////////////////////////////////////////////////////
//
// Burton Computer Corporation
// http://www.burton-computer.com
// http://www.cooldevtools.com
// $Id$
//
// Copyright (C) 2000 Burton Computer Corporation
// ALL RIGHTS RESERVED
//
// This program is open source software; you can redistribute it
// and/or modify it under the terms of the Q Public License (QPL)
// version 1.0. Use of this software in whole or in part, including
// linking it (modified or unmodified) into other programs is
// subject to the terms of the QPL.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// Q Public License for more details.
//
// You should have received a copy of the Q Public License
// along with this program; see the file LICENSE.txt.  If not, visit
// the Burton Computer Corporation or CoolDevTools web site
// QPL pages at:
//
//    http://www.burton-computer.com/qpl.html
//    http://www.cooldevtools.com/qpl.html
//


package org.cooldevtools.coffee_server.services.nntp.protocol;

import java.io.IOException;
import org.cooldevtools.coffee_server.services.nntp.pub.*;

/**
   This is a VERY CRUDE little program to copy all posts to all
   newsgroups on a source server to a destination server.  It is
   intended to serve as a simple mechanism for migrating from
   the serialized repository to the JDBC repository.

   It is NOT intended to be a well written program!
 */
public class transfer
{
   transfer(String src_host,
            int src_port,
            String dst_host,
            int dst_port)
   throws IOException
   {
      m_src = new ServerConnection();
      m_src.setHost(src_host, src_port);

      m_dst = new ServerConnection();
      m_dst.setHost(dst_host, dst_port);
      m_dst.setIdentity("admin", "admin");
   }

   private void transferUsingStat(String msg_id)
   throws IOException
   {
      if (m_dst.stat(msg_id, null) != null) {
         return;
      }

      String[] message = m_src.article();
      m_dst.post(message);
   }

   private void transferUsingIHave(String msg_id,
                                   boolean use_id)
   throws IOException
   {
      if (m_dst.ihaveQuery(msg_id)) {
         String[] message = m_src.article();
         m_dst.ihaveSend(message);
      }
   }

   private void transferNews(String[] groups)
   throws IOException
   {
      for (int i = 0; i < groups.length; i++) {
         m_src.setGroup(groups[i]);
         m_dst.setGroup(groups[i]);
         String msg_id = m_src.stat();
         while (msg_id != null) {
            transferUsingIHave(msg_id, false);
            msg_id = m_src.nextMessageId();
         }
      }
   }

   private void updateNews(String name_pattern,
                           String date,
                           String time)
   throws IOException
   {
      String[] msg_ids = m_src.newNews(name_pattern, date + " " + time);
      for (int i = 0; i < msg_ids.length; i++) {
         transferUsingIHave(msg_ids[i], true);
      }
   }
 
   private void createNewsGroup(String group_name)
   throws IOException
   {
      String[] message = {
         "From: transfer_program",
         "Newsgroups: " + group_name,
         "Control: newgroup " + group_name,
         ""
      };
      m_dst.post(message);
   }

   private String[] getGroups(String name_pattern)
   throws IOException
   {
      if (name_pattern.indexOf('*') == -1) {
         String[] groups = { name_pattern };
         return groups;
      }
 
      return m_src.listNewsGroupNames(name_pattern);
   }

   void go(String name_pattern,
           String date,
           String time)
   throws IOException
   {
      String[] groups = getGroups(name_pattern);
      for (int i = 0; i < groups.length; i++) {
         if (!m_dst.setGroup(groups[i])) {
            createNewsGroup(groups[i]);
         }
               
         if (date == null) {
            transferNews(groups);
         } else {
            updateNews(name_pattern, date, time);
         }

         m_src.quit();
         m_dst.quit();
      }
   }

   public static void main(String[] args)
   throws IOException
   {
      String date = null;
      String time = null;

      if (args.length == 7) {
         date = args[5];
         time = args[6];
      } else if (args.length != 5) {
         System.err.println("usage: source_host source_port dest_host dest_port pattern [date time]");
         System.exit(1);
      }

      String src_host = args[0];
      int    src_port = Integer.parseInt(args[1]);
      String dst_host = args[2];
      int    dst_port = Integer.parseInt(args[3]);
      String pattern  = args[4];

      transfer obj = new transfer(src_host, src_port, dst_host, dst_port);
      obj.go(pattern, date, time);
   }

   private ServerConnection m_src;
   private ServerConnection m_dst;
}
