///###////////////////////////////////////////////////////////////////////////
//
// Burton Computer Corporation
// http://www.burton-computer.com
// http://www.cooldevtools.com
// $Id$
//
// Copyright (C) 2000 Burton Computer Corporation
// ALL RIGHTS RESERVED
//
// This program is open source software; you can redistribute it
// and/or modify it under the terms of the Q Public License (QPL)
// version 1.0. Use of this software in whole or in part, including
// linking it (modified or unmodified) into other programs is
// subject to the terms of the QPL.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// Q Public License for more details.
//
// You should have received a copy of the Q Public License
// along with this program; see the file LICENSE.txt.  If not, visit
// the Burton Computer Corporation or CoolDevTools web site
// QPL pages at:
//
//    http://www.burton-computer.com/qpl.html
//    http://www.cooldevtools.com/qpl.html
//


package org.cooldevtools.coffee_server.services.nntp.pub;

import java.util.*;
import org.cooldevtools.utility.*;
import org.cooldevtools.coffee_server.framework.*;

public interface NewsGroup
{
   public boolean isNewerThan(Date when)
   throws CoffeeServiceException;

   public long getAgeInSeconds()
   throws CoffeeServiceException;

   public void postMessage(User user,
                           Message message)
   throws CoffeeServiceException;

   public long getLowMessageIndex()
   throws CoffeeServiceException;

   public long getHighMessageIndex()
   throws CoffeeServiceException;

   public long getMessageCount()
   throws CoffeeServiceException;

   public Message getMessage(long index)
   throws CoffeeServiceException;

   public boolean isValidMessageIndex(long index)
   throws CoffeeServiceException;

   public String getMessageOverview(long index)
   throws CoffeeServiceException;

   public String getName()
   throws CoffeeServiceException;

   public String getDescription()
   throws CoffeeServiceException;

   public String getEmailAddress()
   throws CoffeeServiceException;

   public void changeAttributes(String name,
                                String email_address,
                                String description)
   throws CoffeeServiceException;

   public int listGroup(long start_index,
                        long[] indexes,
                        long max_to_return)
   throws CoffeeServiceException;

   public static final String PROP_MAX_MESSAGE_SIZE = "max_message_size";
   public static final String PROP_MAX_MESSAGE_DAYS = "max_message_days";
}
