///###////////////////////////////////////////////////////////////////////////
//
// Burton Computer Corporation
// http://www.burton-computer.com
// http://www.cooldevtools.com
// $Id$
//
// Copyright (C) 2000 Burton Computer Corporation
// ALL RIGHTS RESERVED
//
// This program is open source software; you can redistribute it
// and/or modify it under the terms of the Q Public License (QPL)
// version 1.0. Use of this software in whole or in part, including
// linking it (modified or unmodified) into other programs is
// subject to the terms of the QPL.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// Q Public License for more details.
//
// You should have received a copy of the Q Public License
// along with this program; see the file LICENSE.txt.  If not, visit
// the Burton Computer Corporation or CoolDevTools web site
// QPL pages at:
//
//    http://www.burton-computer.com/qpl.html
//    http://www.cooldevtools.com/qpl.html
//

package org.cooldevtools.coffee_server.services.nntp.pub;

import org.cooldevtools.coffee_server.framework.*;

public class NoneRole
implements Role
{
   public boolean canShutdown()
   throws CoffeeServiceException
   {
      return false;
   }

   public boolean canRead()
   throws CoffeeServiceException
   {
      return false;
   }

   public boolean canPost()
   throws CoffeeServiceException
   {
      return false;
   }

   public boolean canCreateNewsGroup(String group_name)
   throws CoffeeServiceException
   {
      return false;
   }

   public boolean canRemoveNewsGroup(NewsGroup group)
   throws CoffeeServiceException
   {
      return false;
   }

   public boolean canReadNewsGroup(NewsGroup group)
   throws CoffeeServiceException
   {
      return false;
   }

   public boolean canReadMessage(Message m)
   throws CoffeeServiceException
   {
      NewsGroup[] groups = m.getNewsGroups();
      for (int i = 0; i < groups.length; i++) {
         if (canReadNewsGroup(groups[i])) {
            return true;
         }
      }
      return false;
   }

   public boolean canPostToNewsGroup(NewsGroup group)
   throws CoffeeServiceException
   {
      return false;
   }

   public boolean canCancelMessage(Message m)
   throws CoffeeServiceException
   {
      return false;
   }

   public boolean canDefineRole(String rolename)
   throws CoffeeServiceException
   {
      return false;
   }

   public boolean canListRole(String rolename)
   throws CoffeeServiceException
   {
      return false;
   }

   public boolean canDeleteRole(String rolename)
   throws CoffeeServiceException
   {
      return false;
   }

   public boolean canListRoles()
   throws CoffeeServiceException
   {
      return false;
   }

   public boolean canDefineUser(String username)
   throws CoffeeServiceException
   {
      return false;
   }

   public boolean canListUser(String username)
   throws CoffeeServiceException
   {
      return false;
   }

   public boolean canDeleteUser(String username)
   throws CoffeeServiceException
   {
      return false;
   }

   public boolean canListUsers()
   throws CoffeeServiceException
   {
      return false;
   }

   public boolean canChangeUserPassword(String user_to_change)
   throws CoffeeServiceException
   {
      return false;
   }

   public boolean canUseRoles(String[] roles)
   throws CoffeeServiceException
   {
      return false;
   }
}
