///###////////////////////////////////////////////////////////////////////////
//
// Burton Computer Corporation
// http://www.burton-computer.com
// http://www.cooldevtools.com
// $Id$
//
// Copyright (C) 2000 Burton Computer Corporation
// ALL RIGHTS RESERVED
//
// This program is open source software; you can redistribute it
// and/or modify it under the terms of the Q Public License (QPL)
// version 1.0. Use of this software in whole or in part, including
// linking it (modified or unmodified) into other programs is
// subject to the terms of the QPL.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// Q Public License for more details.
//
// You should have received a copy of the Q Public License
// along with this program; see the file LICENSE.txt.  If not, visit
// the Burton Computer Corporation or CoolDevTools web site
// QPL pages at:
//
//    http://www.burton-computer.com/qpl.html
//    http://www.cooldevtools.com/qpl.html
//

package org.cooldevtools.coffee_server.services.nntp.pub;

import org.cooldevtools.coffee_server.framework.*;

public interface RoleRepository
{
  public Role getDefaultRole()
  throws CoffeeServiceException;

  public Role getRole(String rolename)
  throws CoffeeServiceException, InvalidUserOrPasswordException;

  public void defineRole(String rolename,
			 String admin_perm,
                         String[] role_patterns,
                         String[] group_patterns,
                         String[] group_perms)
  throws CoffeeServiceException;

  public String[] getRoleNames()
  throws CoffeeServiceException;

  public void deleteRole(String rolename)
  throws CoffeeServiceException;

  public String[] getRoleDefinition(String rolename)
  throws CoffeeServiceException;

  public static final String PERM_READ   = "R";
  public static final String PERM_POST   = "P";
  public static final String PERM_CANCEL = "C";
  public static final String PERM_ADMIN  = "A";
  public static final String PERM_NONE   = "X";

  public static final String ADMIN_NONE  = "X";
  public static final String ADMIN_USERS = "U";
  public static final String ADMIN_ROLES = "R";
}
