///###////////////////////////////////////////////////////////////////////////
//
// Burton Computer Corporation
// http://www.burton-computer.com
// http://www.cooldevtools.com
// $Id$
//
// Copyright (C) 2000 Burton Computer Corporation
// ALL RIGHTS RESERVED
//
// This program is open source software; you can redistribute it
// and/or modify it under the terms of the Q Public License (QPL)
// version 1.0. Use of this software in whole or in part, including
// linking it (modified or unmodified) into other programs is
// subject to the terms of the QPL.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// Q Public License for more details.
//
// You should have received a copy of the Q Public License
// along with this program; see the file LICENSE.txt.  If not, visit
// the Burton Computer Corporation or CoolDevTools web site
// QPL pages at:
//
//    http://www.burton-computer.com/qpl.html
//    http://www.cooldevtools.com/qpl.html
//


package org.cooldevtools.coffee_server.services.nntp.test;

import java.io.*;
import java.net.*;
import java.util.*;

class ResponseCode {
   ResponseCode()
   {
   }

   ResponseCode(String line)
   {
      init(line);
   }

   void init(String line)
   {
      int space_index = line.indexOf(" ");
      m_message = line.substring(space_index + 1);
      m_code = Integer.parseInt(line.substring(0, space_index));
   }

   final String error(String command)
   {
      StringBuffer buffer = new StringBuffer();
      buffer.append("unexpected response for command '");
      buffer.append(command);
      buffer.append("': CODE(");
      buffer.append(m_code);
      buffer.append(") MESSAGE(");
      buffer.append(m_message);
      buffer.append(")");
      return buffer.toString();
   }

   final void verify(String command,
                     int expected)
   throws IOException
   {
      int[] expected_array = { expected };
      verify(command, expected_array);
   }

   final void verify(String command,
                     int[] expected)
   throws IOException
   {
      for (int i = 0; i < expected.length; i++) {
         if (m_code == expected[i]) {
            return;
         }
      }
      throw new IOException(error(command));
   }

   final int getCode()
   {
      return m_code;
   }

   final String getMessage()
   {
      return m_message;
   }

   int m_code;
   String m_message;
}
