///###////////////////////////////////////////////////////////////////////////
//
// Burton Computer Corporation
// http://www.burton-computer.com
// http://www.cooldevtools.com
// $Id$
//
// Copyright (C) 2000 Burton Computer Corporation
// ALL RIGHTS RESERVED
//
// This program is open source software; you can redistribute it
// and/or modify it under the terms of the Q Public License (QPL)
// version 1.0. Use of this software in whole or in part, including
// linking it (modified or unmodified) into other programs is
// subject to the terms of the QPL.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// Q Public License for more details.
//
// You should have received a copy of the Q Public License
// along with this program; see the file LICENSE.txt.  If not, visit
// the Burton Computer Corporation or CoolDevTools web site
// QPL pages at:
//
//    http://www.burton-computer.com/qpl.html
//    http://www.cooldevtools.com/qpl.html
//


package org.cooldevtools.coffee_server.services.test;

import java.io.*;
import java.net.*;
import java.awt.*;
import java.util.*;
import org.cooldevtools.hdl.*;
import org.cooldevtools.coffee_server.config.*;
import org.cooldevtools.coffee_server.framework.*;

public class Shutdown
extends BasicCoffeeServiceManager
implements CoffeeService, Runnable
{
   public Shutdown(CoffeeServer server)
   {
      m_server = server;
   }

   public void run()
   {
      System.out.println("shutting down server...");
      m_server.shutdown();
      System.out.println("good night gracy!");
      System.exit(0);
   }

   public void serviceRequest(ClientRequest req)
   throws IOException, CoffeeServiceException
   {
      Thread t = new Thread(this);
      t.start();
   }

   public void shutdown()
   throws CoffeeServiceException
   {
      System.out.println("server told me to shut down");
   }

   public CoffeeService newServiceInstance()
   {
      return this;
   }

   private CoffeeServer m_server;
}
