///###////////////////////////////////////////////////////////////////////////
//
// Burton Computer Corporation
// http://www.burton-computer.com
// http://www.cooldevtools.com
// $Id$
//
// Copyright (C) 2000 Burton Computer Corporation
// ALL RIGHTS RESERVED
//
// This program is open source software; you can redistribute it
// and/or modify it under the terms of the Q Public License (QPL)
// version 1.0. Use of this software in whole or in part, including
// linking it (modified or unmodified) into other programs is
// subject to the terms of the QPL.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// Q Public License for more details.
//
// You should have received a copy of the Q Public License
// along with this program; see the file LICENSE.txt.  If not, visit
// the Burton Computer Corporation or CoolDevTools web site
// QPL pages at:
//
//    http://www.burton-computer.com/qpl.html
//    http://www.cooldevtools.com/qpl.html
//

package org.cooldevtools.utility;

public class Assert
{
   /**
    * Precondition tester.
    */
   public static final void pre(boolean test)
   {
      if (!test) {
         throw new AssertionFailure("Precondition violation.");
      }
   }

   /**
    * Postcondition tester.
    */
   public static final void post(boolean test)
   {
      if (!test) {
         throw new AssertionFailure("Postcondition violation.");
      }
   }

   /**
    * Invariant tester.
    */
   public static final void inv(boolean test)
   {
      if (!test) {
         throw new AssertionFailure("Invariant violation.");
      }
   }

   public static final void impossible()
   {
      throw new AssertionFailure("Impossible");
   }

   public static final void impossible(String msg)
   {
      throw new AssertionFailure(msg);
   }

   public static final void impossible(Exception ex)
   {
      throw new ImpossibleException(ex);
   }

   public static void printStackTrace()
   {
      try {
         throw new Exception("STACK TRACE");
      } catch (Exception ex) {
         ex.printStackTrace();
      }
   }

   public static final boolean DEBUG = true;
}
