///###////////////////////////////////////////////////////////////////////////
//
// Burton Computer Corporation
// http://www.burton-computer.com
// http://www.cooldevtools.com
// $Id$
//
// Copyright (C) 2000 Burton Computer Corporation
// ALL RIGHTS RESERVED
//
// This program is open source software; you can redistribute it
// and/or modify it under the terms of the Q Public License (QPL)
// version 1.0. Use of this software in whole or in part, including
// linking it (modified or unmodified) into other programs is
// subject to the terms of the QPL.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// Q Public License for more details.
//
// You should have received a copy of the Q Public License
// along with this program; see the file LICENSE.txt.  If not, visit
// the Burton Computer Corporation or CoolDevTools web site
// QPL pages at:
//
//    http://www.burton-computer.com/qpl.html
//    http://www.cooldevtools.com/qpl.html
//

package org.cooldevtools.utility;

import java.util.Enumeration;
import java.util.Hashtable;

public class SuperHashtable extends Hashtable implements Cloneable
{
    public SuperHashtable()
    {
    }

    public SuperHashtable(int initialCapacity)
    {
      super(initialCapacity);
    }

    public SuperHashtable(int initialCapacity,
			  float loadFactor)
    {
      super(initialCapacity, loadFactor);
    }

    public SuperHashtable(Hashtable ht)
    {
        super(ht.size());
        synchronized (ht) {
 	    Enumeration en = ht.keys();
	    while (en.hasMoreElements()) {
	        Object key = en.nextElement();
		put(key, ht.get(key));
	    }
	}
    }

    public Object clone()
    {
       return new SuperHashtable(this);
    }

    public synchronized void copyInto(Object[] array)
    {
      SuperVector.copyEnumToArray(elements(), array, 0);
    }

    public synchronized void copyKeysInto(Object[] array)
    {
      SuperVector.copyEnumToArray(keys(), array, 0);
    }

    public synchronized Object[] getValues()
    {
      return SuperVector.enumToArray(elements());
    }

    public synchronized Long[] getLongs()
    {
       Long[] result = new Long[ size() ];
       SuperVector.copyEnumToArray(elements(), result, 0);
       return result;
    }
 
    public synchronized Object[] getValues(Class _class)
    {
      return SuperVector.enumToArray(_class, elements());
    }

    public synchronized Object[] getKeys()
    {
      return SuperVector.enumToArray(keys());
    }

    public synchronized Object[] getKeys(Class _class)
    {
      return SuperVector.enumToArray(_class, keys());
    }

    public synchronized String[] getKeyStrings()
    {
       String[] result = new String[ size() ];
       SuperVector.copyEnumToArray(keys(), result, 0);
       return result;
    }
}
