///###////////////////////////////////////////////////////////////////////////
//
// Burton Computer Corporation
// http://www.burton-computer.com
// http://www.cooldevtools.com
// $Id$
//
// Copyright (C) 2000 Burton Computer Corporation
// ALL RIGHTS RESERVED
//
// This program is open source software; you can redistribute it
// and/or modify it under the terms of the Q Public License (QPL)
// version 1.0. Use of this software in whole or in part, including
// linking it (modified or unmodified) into other programs is
// subject to the terms of the QPL.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// Q Public License for more details.
//
// You should have received a copy of the Q Public License
// along with this program; see the file LICENSE.txt.  If not, visit
// the Burton Computer Corporation or CoolDevTools web site
// QPL pages at:
//
//    http://www.burton-computer.com/qpl.html
//    http://www.cooldevtools.com/qpl.html
//

package org.cooldevtools.utility.logging;

public class MessagePriority
extends org.cooldevtools.utility.EnumType
{
   private MessagePriority(int index, String name)
   {
      super(index, name);
   }

   public boolean lessThan(MessagePriority other)
   {
      return other.getIndex() < getIndex();
   }

   public static final MessagePriority LOG_EMERGENCY = new MessagePriority(0, "emergency");
   public static final MessagePriority LOG_ALERT = new MessagePriority(1, "alert");
   public static final MessagePriority LOG_CRITICAL = new MessagePriority(2, "critical");
   public static final MessagePriority LOG_ERROR = new MessagePriority(3, "error");
   public static final MessagePriority LOG_WARNING = new MessagePriority(4, "warning");
   public static final MessagePriority LOG_NOTICE = new MessagePriority(5, "notice");
   public static final MessagePriority LOG_INFO = new MessagePriority(6, "info");
   public static final MessagePriority LOG_DEBUG = new MessagePriority(7, "debug");

   public static final MessagePriority[] ALL = {
      LOG_EMERGENCY,
      LOG_ALERT,
      LOG_CRITICAL,
      LOG_ERROR,
      LOG_WARNING,
      LOG_NOTICE,
      LOG_INFO,
      LOG_DEBUG,
   };
}
