///###////////////////////////////////////////////////////////////////////////
//
// Burton Computer Corporation
// http://www.burton-computer.com
// http://www.cooldevtools.com
// $Id$
//
// Copyright (C) 2000 Burton Computer Corporation
// ALL RIGHTS RESERVED
//
// This program is open source software; you can redistribute it
// and/or modify it under the terms of the Q Public License (QPL)
// version 1.0. Use of this software in whole or in part, including
// linking it (modified or unmodified) into other programs is
// subject to the terms of the QPL.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// Q Public License for more details.
//
// You should have received a copy of the Q Public License
// along with this program; see the file LICENSE.txt.  If not, visit
// the Burton Computer Corporation or CoolDevTools web site
// QPL pages at:
//
//    http://www.burton-computer.com/qpl.html
//    http://www.cooldevtools.com/qpl.html
//

package org.cooldevtools.utility.logging;

public class SyslogFacility
extends org.cooldevtools.utility.EnumType
{
   private SyslogFacility(int index, String name)
   {
      super(index, name);
   }

   public int getCode()
   {
      return getIndex() << 3;
   }

   public static final SyslogFacility LOG_KERNEL = new SyslogFacility(0, "LOG_KERNEL");
   public static final SyslogFacility LOG_USER   = new SyslogFacility(1, "LOG_USER");
   public static final SyslogFacility LOG_MAIL   = new SyslogFacility(2, "LOG_MAIL");
   public static final SyslogFacility LOG_DAEMON = new SyslogFacility(3, "LOG_DAEMON");
   public static final SyslogFacility LOG_AUTH   = new SyslogFacility(4, "LOG_AUTH");
   public static final SyslogFacility LOG_SYSLOG = new SyslogFacility(5, "LOG_SYSLOG");
   public static final SyslogFacility LOG_LPR    = new SyslogFacility(6, "LOG_LPR");
   public static final SyslogFacility LOG_NEWS   = new SyslogFacility(7, "LOG_NEWS");
   public static final SyslogFacility LOG_UUCP   = new SyslogFacility(8, "LOG_UUCP");
   public static final SyslogFacility LOG_CRON   = new SyslogFacility(15, "LOG_CRON");
   public static final SyslogFacility LOG_LOCAL0 = new SyslogFacility(16, "LOG_LOCAL0");
   public static final SyslogFacility LOG_LOCAL1 = new SyslogFacility(17, "LOG_LOCAL1");
   public static final SyslogFacility LOG_LOCAL2 = new SyslogFacility(18, "LOG_LOCAL2");
   public static final SyslogFacility LOG_LOCAL3 = new SyslogFacility(19, "LOG_LOCAL3");
   public static final SyslogFacility LOG_LOCAL4 = new SyslogFacility(20, "LOG_LOCAL4");
   public static final SyslogFacility LOG_LOCAL5 = new SyslogFacility(21, "LOG_LOCAL5");
   public static final SyslogFacility LOG_LOCAL6 = new SyslogFacility(22, "LOG_LOCAL6");
   public static final SyslogFacility LOG_LOCAL7 = new SyslogFacility(23, "LOG_LOCAL7");

   public static final SyslogFacility[] ALL = {
      LOG_KERNEL,
      LOG_USER,
      LOG_MAIL,
      LOG_DAEMON,
      LOG_AUTH,
      LOG_SYSLOG,
      LOG_LPR,
      LOG_NEWS,
      LOG_UUCP,
      LOG_CRON,
      LOG_LOCAL0,
      LOG_LOCAL1,
      LOG_LOCAL2,
      LOG_LOCAL3,
      LOG_LOCAL4,
      LOG_LOCAL5,
      LOG_LOCAL6,
      LOG_LOCAL7,
   };
}
