///###////////////////////////////////////////////////////////////////////////
//
// Burton Computer Corporation
// http://www.burton-computer.com
// http://www.cooldevtools.com
// $Id$
//
// Copyright (C) 2000 Burton Computer Corporation
// ALL RIGHTS RESERVED
//
// This program is open source software; you can redistribute it
// and/or modify it under the terms of the Q Public License (QPL)
// version 1.0. Use of this software in whole or in part, including
// linking it (modified or unmodified) into other programs is
// subject to the terms of the QPL.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// Q Public License for more details.
//
// You should have received a copy of the Q Public License
// along with this program; see the file LICENSE.txt.  If not, visit
// the Burton Computer Corporation or CoolDevTools web site
// QPL pages at:
//
//    http://www.burton-computer.com/qpl.html
//    http://www.cooldevtools.com/qpl.html
//

package org.cooldevtools.workflow;

public interface Queue
{
  /**
     Close the queue.  All waiting workers will receive a
     QueueClosedException when the last object has been
     removed from the queue.
  */
  public void close();

  /**
     Close the queue.  All waiting workers will receive a
     QueueClosedException immediately even if there are
     objects available in the queue.
  */
  public void closeImmediately();

  /**
     Put an object into the queue.  The next waiting worker will
     be given the object.
  */
  public void put(Object item);

  /**
     Get the next available object from the queue.
     Throws QueueClosedException if the queue has been closed and no
     items remain.
  */
  public Object get()
    throws QueueClosedException;
}
